package jp.co.sds_corp.fxchart.graph;

import java.io.BufferedReader;
import java.io.FileReader;

import jp.co.sds_corp.util.common.CmnDate;
import jp.co.sds_corp.util.common.CmnString;

/**
* 公表相場を保持します。
*/
public class Quote
{
	String	ccy;
	String	file;
	int nStat;
	double	dTTS;
	double	dTTB;
	double	dTTM;
	CmnDate	date;
	boolean	bToday;

	/**
	* 通貨(ccy)を設定します。
	* @param	var		設定するデータ
	*/
	public void setCcy( String var ) {
		this.ccy = var ;
	}
	/**
	* 通貨(ccy)を取得します。
	* @return	ccy1の内容
	*/
	public String getCcy() {
		return ccy;
	}

	/**
	* ファイル(file)を設定します。
	* @param	var		設定するデータ
	*/
	public void setFile( String var ) {
		this.file = var ;
	}
	/**
	* ファイル(file)を取得します。
	* @return	fileの内容
	*/
	public String getFile() {
		return file;
	}

	/**
	* TTS(tts)を設定します。
	* @param	var		設定するデータ
	*/
	private void setTTS( double var ) {
		this.dTTS = var ;
	}
	/**
	* TTS(tts)を取得します。
	* @return	ttsの内容
	*/
	public double getTTS() {
		return dTTS;
	}

	/**
	* TTB(ttb)を設定します。
	* @param	var		設定するデータ
	*/
	private void setTTB( double var ) {
		this.dTTB = var ;
	}
	/**
	* TTB(ttb)を取得します。
	* @return	ttbの内容
	*/
	public double getTTB() {
		return dTTB;
	}

	/**
	* TTM(ttm)を設定します。
	* @param	var		設定するデータ
	*/
	private void setTTM( double var ) {
		this.dTTM = var ;
	}
	/**
	* TTM(ttm)を取得します。
	* @return	ttmの内容
	*/
	public double getTTM() {
		return dTTM;
	}

	/**
	* 日付(date)を設定します。
	* @param	var		設定するデータ
	*/
	private void setDate( CmnDate var ) {
		this.date = var ;
		bToday = false;
		if ( date.getString().equals( new CmnDate().getString())) {
			bToday = true;
		}
	}
	/**
	* 日付(date)を取得します。
	* @return	dateの内容
	*/
	public CmnDate getDate() {
		return date;
	}


	/**
	* 状態(nStat)を取得します。
	* @return	nStatの内容
	*/
	public int getStatus() {
		return nStat;
	}

	public boolean isToday() {
		return bToday;
	}

	void start() {
		nStat = -1;
		bToday = false;
		try {
			BufferedReader rd = new BufferedReader( new FileReader( file ));
			for ( ;; ) {
				String buf = rd.readLine();
				if ( buf == null ) {
					break;
				}
				String[] line = CmnString.getStringToken( buf, "\t" );
				if ( line[0].equals( ccy )) {
					dTTS = Double.valueOf( line[1] ).doubleValue();
					dTTB = Double.valueOf( line[2] ).doubleValue();
					dTTM = ( dTTS + dTTB ) / 2.0;
					setDate( new CmnDate( line[3], "yyyy/MM/dd" ));
					nStat = 0;
					break;
				}
			}
			rd.close();
		} catch ( Exception e ) {
		}
	}
}
